import {Component, Input, OnInit} from '@angular/core'
import {Employee, EmployeeGroup, EmployeePermission, mapped_permissions} from '../../model/employee'

@Component({
  selector: 'cre-permissions-list',
  templateUrl: './permissions-list.component.html',
  styleUrls: ['./permissions-list.component.sass']
})
export class PermissionsListComponent {
  @Input() employee: Employee
  @Input() group: EmployeeGroup

  // @ts-ignore
  private _permissions = Object.values(mapped_permissions).flatMap(p => p)

  constructor() {
  }

  get permissions(): EmployeePermission[] {
    return this.filterPermissions(this.employee ? this.employee.permissions : this.group.permissions)
  }

  private filterPermissions(permissions: EmployeePermission[]) {
    return this._permissions.filter(p => permissions.indexOf(p.permission) >= 0).map(p => p.description)
  }
}
